=== debian/changelog ===
rocdbgapi (5.7.1-2) unstable; urgency=medium

  * Team upload.

  * Changed int types used to build on ppc64el (Closes: #1081303).

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 11 Sep 2024 14:41:56 +0200

rocdbgapi (5.7.1-1) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 22 Apr 2024 01:54:23 -0600

rocdbgapi (5.7.1-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1040516)

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 19 Feb 2024 17:53:03 -0700
