## rocdbgapi 6.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-## Copyright (c) 2019-2023 Advanced Micro Devices, Inc.
+## Copyright (c) 2019-2024 Advanced Micro Devices, Inc.
 ##
 ## Permission is hereby granted, free of charge, to any person obtaining a copy
 ## of this software and associated documentation files (the "Software"), to
@@ -20,10 +20,12 @@
 
 cmake_minimum_required(VERSION 3.8)
 
-project(amd-dbgapi VERSION 0.70.1)
+project(amd-dbgapi VERSION 0.77.2)
 
 include(CheckIncludeFile)
 include(GNUInstallDirs)
+include(CheckCXXSourceCompiles)
+
 # Convert the project's name to uppercase and replace '-' with '_'.
 string(TOUPPER "${PROJECT_NAME}" AMD_DBGAPI_NAME)
 string(REPLACE "-" "_" AMD_DBGAPI_NAME ${AMD_DBGAPI_NAME})
@@ -111,26 +113,34 @@
   target_compile_definitions(amd-dbgapi PRIVATE WITH_API_TRACING)
 endif()
 
-find_file(
-  PCI_IDS_PATH
-  NAMES
-    pci.ids
-  PATHS
-    /usr/share/misc
-    /usr/share/hwdata
-  NO_DEFAULT_PATH
-)
-# CMake-3.18 adds the REQUIRED parameter to find_file, but we cannot rely on it
-# yet.  Check manually the file is found until then.
-if("${PCI_IDS_PATH}" STREQUAL "PCI_IDS_PATH-NOTFOUND")
-  message(FATAL_ERROR "Cannot found the pci.ids file. Use PCI_IDS_PATH to specify known path.")
-endif()
-message(STATUS "Using pci.ids file: ${PCI_IDS_PATH}")
-set_source_files_properties(
-  src/os_driver.cpp
-  PROPERTIES
-    COMPILE_DEFINITIONS "PCI_IDS_PATH=\"${PCI_IDS_PATH}\""
-)
+if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
+  set(CMAKE_REQUIRED_FLAGS_BKP "${CMAKE_REQUIRED_FLAGS}")
+  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -std=c++17")
+  # For some platforms (PPC64), linux/types.h uses L64, but this code assumes
+  # LL64 (i.e.  __u64 should be a long long unsigned, not long unsigned).
+  check_cxx_source_compiles(
+    "#include <linux/types.h>
+     #include <type_traits>
+     int main () { static_assert (std::is_same_v<long long unsigned, __u64>); return 0; }"
+     LINUX_TYPES_HAS_LL64)
+
+  if(NOT LINUX_TYPES_HAS_LL64)
+    # Check if using __SANE_USERSPACE_TYPES__ gives us LL64
+    check_cxx_source_compiles(
+      "#define __SANE_USERSPACE_TYPES__
+       #include <linux/types.h>
+       #include <type_traits>
+       int main () { static_assert (std::is_same_v<long long unsigned, __u64>); return 0; }"
+       LINUX_TYPES_LL64_NEEDS_SANE_USERSPACE_TYPES)
+    if(LINUX_TYPES_LL64_NEEDS_SANE_USERSPACE_TYPES)
+      target_compile_definitions(amd-dbgapi PRIVATE "__SANE_USERSPACE_TYPES__")
+    else()
+      message(FATAL_ERROR
+              "A LL64 configuration is required for the Linux backend")
+    endif()
+  endif()
+  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS_BKP}")
+endif()
 
 find_package(amd_comgr REQUIRED CONFIG
   PATHS
@@ -276,14 +286,14 @@
 set(CPACK_RPM_COMPONENT_INSTALL ON)
 set(CPACK_DEBIAN_DEV_PACKAGE_NAME "rocm-dbgapi")
 set(CPACK_RPM_DEV_PACKAGE_NAME "rocm-dbgapi")
-set(CPACK_RPM_DEV_PACKAGE_REQUIRES "rocm-core, comgr >= 1.2.0, hwdata")
-set(CPACK_DEBIAN_DEV_PACKAGE_DEPENDS "comgr(>=1.2.0), rocm-core, pci.ids")
+set(CPACK_RPM_DEV_PACKAGE_REQUIRES "rocm-core, comgr >= 1.2.0")
+set(CPACK_DEBIAN_DEV_PACKAGE_DEPENDS "comgr(>=1.2.0), rocm-core")
 # Debian package specific variable for ASAN
 set(CPACK_DEBIAN_ASAN_PACKAGE_NAME "rocm-dbgapi-asan")
-set(CPACK_DEBIAN_ASAN_PACKAGE_DEPENDS "comgr-asan(>=1.2.0), rocm-core-asan, pci.ids")
+set(CPACK_DEBIAN_ASAN_PACKAGE_DEPENDS "comgr-asan(>=1.2.0), rocm-core-asan, libdrm-amdgpu-common | libdrm-common")
 # RPM package specific variable for ASAN
 set(CPACK_RPM_ASAN_PACKAGE_NAME "rocm-dbgapi-asan" )
-set(CPACK_RPM_ASAN_PACKAGE_REQUIRES "rocm-core-asan, comgr-asan >= 1.2.0, hwdata")
+set(CPACK_RPM_ASAN_PACKAGE_REQUIRES "rocm-core-asan, comgr-asan >= 1.2.0, libdrm-amdgpu-common")
 
 # Debian package specific variables
 if(DEFINED ENV{CPACK_DEBIAN_PACKAGE_RELEASE})
@@ -294,7 +304,7 @@
 message("Using CPACK_DEBIAN_PACKAGE_RELEASE ${CPACK_DEBIAN_PACKAGE_RELEASE}")
 set(CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT")
 
-set(CPACK_DEBIAN_PACKAGE_DEPENDS "comgr(>=1.2.0), rocm-core, pci.ids")
+set(CPACK_DEBIAN_PACKAGE_DEPENDS "comgr(>=1.2.0), rocm-core, libdrm-amdgpu-common | libdrm-common")
 
 if(DEFINED ENV{CPACK_RPM_PACKAGE_RELEASE})
   set(CPACK_RPM_PACKAGE_RELEASE $ENV{CPACK_RPM_PACKAGE_RELEASE})
@@ -308,23 +318,3 @@
 execute_process(COMMAND rpm --eval %{?dist}
                  RESULT_VARIABLE PROC_RESULT
                  OUTPUT_VARIABLE EVAL_RESULT
-                 OUTPUT_STRIP_TRAILING_WHITESPACE)
-if(PROC_RESULT EQUAL "0" AND NOT EVAL_RESULT STREQUAL "")
-  string(APPEND CPACK_RPM_PACKAGE_RELEASE "%{?dist}")
-endif()
-set(CPACK_RPM_FILE_NAME "RPM-DEFAULT")
-
-set(CPACK_RPM_PACKAGE_REQUIRES "comgr >= 1.2.0, hwdata")
-
-# Debian package specific variables
-#set(CPACK_DEBIAN_PACKAGE_HOMEPAGE
-#  "https://github.com/RadeonOpenCompute/")
-
-# RPM package specific variables
-if(DEFINED CPACK_PACKAGING_INSTALL_PREFIX)
-  set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION
-    "${CPACK_PACKAGING_INSTALL_PREFIX}")
-endif()
-
-# Remove dependency on rocm-core if -DROCM_DEP_ROCMCORE=ON not given to cmake
-if(NOT ROCM_DEP_ROCMCORE)
