=== debian/changelog ===
rocdbgapi (6.4.3-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * d/gbp.conf: change debian branch debian/unstable for consistency
    with other packages maintained by the Debian ROCm Team
  * Update my email address and copyright information
  * Update Standards-Version to 4.7.2
    * No changes required
  * Add prompt for rocminfo output to library bug reports

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Fri, 07 Nov 2025 19:37:58 -0700

rocdbgapi (6.4.3-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 6.4.2.
  * 1000-portable-int-sizes.patch: drop as included upstream.
  * Run wrap-and-sort.
  * debian/copyright: update.
  * debian/copyright: add myself.
  * debian/control: build-deps on libamd-comgr-dev (>= 6.1.2~).
  * debian/librocm-dbgapi0.symbols: refreshed.
  * debian/gbp.conf: added. Switch to DEP14 git branch layout.
  * debian/salsa-ci.yml: added. Variable set Experimental release.
  * New upstream version 6.4.3.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Mon, 11 Aug 2025 13:25:35 +0200
