=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: devel
 Homepage: https://github.com/ROCm/ROCdbgapi
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/rocdbgapi.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/rocdbgapi
 Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
+Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libamd-comgr-dev (>= 5.7.1~),
+               libamd-comgr-dev (>= 6.1.2~),
                libhsa-runtime-dev,
                pci.ids
 Rules-Requires-Root: no
@@ -17,7 +17,7 @@
 Package: librocm-dbgapi0
 Section: libs
 Architecture: amd64 arm64 ppc64el
-Depends: ${misc:Depends}, ${shlibs:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: AMD GPU debugger support - library
  The ROCdbpgapi library provides debugging routines to inspect and
  control programs running on AMD GPUs. This library is used by
@@ -31,7 +31,9 @@
 Package: amd-dbgapi-dev
 Section: libdevel
 Architecture: amd64 arm64 ppc64el
-Depends: librocm-dbgapi0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
+Depends: librocm-dbgapi0 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: AMD GPU debugger support - headers
  The ROCdbpgapi library provides debugging routines to inspect and
  control programs running on AMD GPUs. This library is used by
