=== debian/watch ===
Version: 5

Source: https://github.com/rocm/rocdbgapi/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocdbgapi-$1.tar.gz%
