## rocdbgapi 7.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,11 +20,13 @@
 
 cmake_minimum_required(VERSION 3.8)
 
-project(amd-dbgapi VERSION 0.77.2)
+project(amd-dbgapi VERSION 0.77.4)
 
 include(CheckIncludeFile)
 include(GNUInstallDirs)
 include(CheckCXXSourceCompiles)
+
+set(CPACK_PACKAGE_NAME rocm-dbgapi)
 
 # Convert the project's name to uppercase and replace '-' with '_'.
 string(TOUPPER "${PROJECT_NAME}" AMD_DBGAPI_NAME)
@@ -77,8 +79,28 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/amd-dbgapi.pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/share/pkgconfig/amd-dbgapi.pc @ONLY)
 
-file(GLOB SOURCES "src/*.cpp")
-add_library(amd-dbgapi SHARED ${SOURCES})
+add_library(amd-dbgapi SHARED
+  src/agent.cpp
+  src/architecture.cpp
+  src/callbacks.cpp
+  src/code_object.cpp
+  src/debug.cpp
+  src/dispatch.cpp
+  src/displaced_stepping.cpp
+  src/event.cpp
+  src/exception.cpp
+  src/initialization.cpp
+  src/logging.cpp
+  src/memory.cpp
+  src/os_driver.cpp
+  src/process.cpp
+  src/queue.cpp
+  src/register.cpp
+  src/utils.cpp
+  src/versioning.cpp
+  src/watchpoint.cpp
+  src/wave.cpp
+  src/workgroup.cpp)
 
 set_target_properties(amd-dbgapi PROPERTIES
   CXX_STANDARD 17
@@ -114,6 +136,8 @@
 endif()
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
+  target_sources(amd-dbgapi PRIVATE src/os_driver_kfd.cpp)
+
   set(CMAKE_REQUIRED_FLAGS_BKP "${CMAKE_REQUIRED_FLAGS}")
   set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -std=c++17")
   # For some platforms (PPC64), linux/types.h uses L64, but this code assumes
@@ -140,6 +164,8 @@
     endif()
   endif()
   set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS_BKP}")
+else()
+  message(FATAL_ERROR "Platform ${CMAKE_SYSTEM_NAME} is not supported")
 endif()
 
 find_package(amd_comgr REQUIRED CONFIG
@@ -234,12 +260,12 @@
 
 install(FILES
   "LICENSE.txt"
-  DESTINATION ${CMAKE_INSTALL_DOCDIR}
+  DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/${CPACK_PACKAGE_NAME}
   COMPONENT dev)
 
 install(FILES
   "LICENSE.txt"
-  DESTINATION ${CMAKE_INSTALL_DOCDIR}-asan
+  DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/${CPACK_PACKAGE_NAME}-asan
   COMPONENT asan)
 
 # Generate the install-tree package.
@@ -266,7 +292,6 @@
   COMPONENT dev)
 
 # Add packaging directives for amd-dbgapi
-set(CPACK_PACKAGE_NAME rocm-dbgapi)
 set(CPACK_PACKAGE_VENDOR "Advanced Micro Devices, Inc.")
 set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
 set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
@@ -304,17 +329,3 @@
 message("Using CPACK_DEBIAN_PACKAGE_RELEASE ${CPACK_DEBIAN_PACKAGE_RELEASE}")
 set(CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT")
 
-set(CPACK_DEBIAN_PACKAGE_DEPENDS "comgr(>=1.2.0), rocm-core, libdrm-amdgpu-common | libdrm-common")
-
-if(DEFINED ENV{CPACK_RPM_PACKAGE_RELEASE})
-  set(CPACK_RPM_PACKAGE_RELEASE $ENV{CPACK_RPM_PACKAGE_RELEASE})
-else()
-  set(CPACK_RPM_PACKAGE_RELEASE "local")
-endif()
-set(CPACK_RPM_PACKAGE_REQUIRES "rocm-core")
-message("Using CPACK_RPM_PACKAGE_RELEASE ${CPACK_RPM_PACKAGE_RELEASE}")
-
-## 'dist' breaks manual builds on debian systems due to empty Provides
-execute_process(COMMAND rpm --eval %{?dist}
-                 RESULT_VARIABLE PROC_RESULT
-                 OUTPUT_VARIABLE EVAL_RESULT
