=== debian/changelog ===
rocdbgapi (7.1.0-0ubuntu2) resolute; urgency=medium

  * Revert to LLVM 21 toolchain (from ROCm LLVM fork)
    - d/control: revert build-depends to llvm-toolchain-21

 -- Igor Luppi <igor.luppi@canonical.com>  Fri, 30 Jan 2026 15:38:07 -0300

rocdbgapi (7.1.0-0ubuntu1) resolute; urgency=medium

  * New upstream version 7.1.0
  * d/control: update maintainer field
  * d/control: update build-depends for src:llvm-toolchain-rocm
  * d/control: Remove unused  from amd-dbgapi-dev
  * d/amd-dbgapi-dev.docs: Install main license file
  * d/not-installed: Ignore unneeded 'asan' license file
  * d/rules: set gensymbols -c4 to be more strict

 -- Igor Luppi <igor.luppi@canonical.com>  Wed, 05 Nov 2025 14:28:12 +0100
