=== debian/control ===
--- 
+++ 
@@ -5,12 +5,13 @@
 Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/rocdbgapi.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/rocdbgapi
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libamd-comgr-dev (>= 6.1.2~),
-               libhsa-runtime-dev,
+               libamd-comgr-dev (>= 7.1.0~),
+               libhsa-runtime-dev (>= 7.1.0~),
                pci.ids
 Rules-Requires-Root: no
 
@@ -32,8 +33,7 @@
 Section: libdevel
 Architecture: amd64 arm64 ppc64el
 Depends: librocm-dbgapi0 (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+         ${misc:Depends}
 Description: AMD GPU debugger support - headers
  The ROCdbpgapi library provides debugging routines to inspect and
  control programs running on AMD GPUs. This library is used by
