=== debian/rules ===
--- 
+++ 
@@ -4,3 +4,7 @@
 
 %:
 	dh $@ -Scmake
+
+# To make sure gensymbols fails the build, -c4 to be more strict
+override_dh_makeshlibs:
+	dh_makeshlibs -V -plibrocm-dbgapi0 -- -c4
